# Get audits

Gets an audit trail of user actions and configuration changes (to accounts, fees, and rates) on a RippleNet instance.

Endpoint: GET /audit
Version: 4.0.0
Security: Bearer

## Query parameters:

  - `page` (integer)
    The page number for paginated results. The value is zero-based, where 0 represents the first page.
Set it to 0 to get the first page of results.

  - `size` (integer)
    Number of payments to return per page.

  - `before` (string)
    Filters for audit events where the range_field value is before this specified time stamp (not inclusive). You can also specify after to create a time range between after and before. If before is specified, range_field must also be specified.

  - `after` (string)
    Filters for audit events where the range_field value is after this specified time stamp (not inclusive). You can also specify before to create a time range between after and before. If after is specified, range_field must also be specified.

  - `range_field` (string)
    Filters payments before/after/between created and modified timestamps (CREATED_AT, MODIFIED_AT). For example, if you specify range_field=CREATED_AT, you would specify a timestamp (in the 24-character ISO 8601 YYYY-MM-DDTHH:mm:ss.sssZ format used in payment objects) as the value for before and/or after to fetch audit events before, after, or between the specified time range(s) (not inclusive). If range_field is specified, before and/or after must also be specified.

  - `actor` (string)
    Filters for audit events based upon actor.

  - `action` (string)
    Filters for audit events based upon action.

  - `level` (string)
    Filters for audit events based upon audit level.
    Enum: "INFO", "WARN", "ERROR"

  - `domain` (string)
    Filters for audit events based upon audit domain.
    Enum: "USER_MANAGEMENT", "CONFIG_MANAGEMENT", "OTHER"

## Response 200 fields (application/json):

  - `first` (boolean)
    true if  this is the first page.

  - `last` (boolean)
    true if  this is the last page.

  - `number` (integer)
    page number

  - `numberOfElements` (integer)
    Number Of elements in this request

  - `size` (integer)
    page size

  - `totalElements` (integer)
    Total number of elements for the given request

  - `totalPages` (integer)
    Total number of pages for the given request

  - `sort` (array)
    Sort details of this page

  - `sort.direction` (string)
    Direction of the sort
    Example: "ASC"

  - `sort.property` (string)

  - `sort.ignoreCase` (boolean)

  - `sort.nullHandling` (string)
    Example: "NULLS_FIRST"

  - `sort.ascending` (boolean)
    Example: true

  - `sort.descending` (boolean)

  - `content` (array)

  - `content.actor` (string)
    Person or middleware who took the action.
    Example: "super_user_client"

  - `content.action` (string)
    Action that triggered the event.
    Example: "KEY_UPDATE"

  - `content.eventId` (string)
    UUID representing the event.
    Example: "3d5d0831-762c-4e0c-980c-635b38fd9caf"

  - `content.message` (string)
    Message describing the audit event.
    Example: "Added public key class PublicKeyRecord {\n    publicKey: MCowBQYDK2VwAyEAb8Q2YzrbTIwrUn7u5Q6hJimp7jBFHx500MfDM4XVNJ0=\n    keyIntent: SIGNING_PUBLIC_KEY\n    keyType: ED_25519\n    keyVersion: 1\n    expiryDateTime: 2089-09-23T17:27:50.331Z\n} for RippleNet address rn.us.ny.new_york"

  - `content.metadata` (string)
    Information about the event, such as IP Address and URI.
    Example: "{\"ip\":\"0:0:0:0:0:0:0:1\",\"uri\":\"/internal/key_service/addresses/rn.us.ny.new_york/keys\"}"

  - `content.domain` (string)
    Represents the audit event domain.
    Enum: "USER_MANAGEMENT", "CONFIG_MANAGEMENT", "OTHER"

  - `content.level` (string)
    Represents the audit event level.
    Enum: "INFO", "WARN", "ERROR"

  - `content.timeStamp` (string)
    Timestamp of the audit event.
    Example: "2019-09-30T22:55:41.365000Z"

## Response 400 fields (application/json):

  - `type` (string)
    URL to the error documentation.
    Example: "https://errors.ripplenet.ripple.com/error/json-processing-error"

  - `title` (string)
    Summary of the returned problem.
    Example: "Invalid Request Object"

  - `detail` (string)
    Description of the returned problem.
    Example: "The request parameter [account_id] is not in the correct format."

  - `status` (number)
    HTTP error code.
    Example: 400

  - `ripplenet_error_code` (string)
    RippleNet specific error code.
    Example: "E0104"

  - `finality` (string)
    Specifies if the request can be retried for a successful response.
    Example: "PERMANENT"


